
:- use_module(library(lists)).



main :-
	generate(1).


	
generate(26) :- !.

generate(Number) :-
	assert(new(2)),
	number_codes(Number, NumberCode),
	append("step", NumberCode, FileName),
	append(FileName, ".cpl", FileNameCPL),
	atom_codes(FileNameCPLAtom, FileNameCPL),
	open(FileNameCPLAtom, write, Stream),
	write_clauses(Stream),
	Next is Number + 1,
	write_graph(1, Next, Stream),
	close(Stream),
	retract(new(_)),
	generate(Next).



write_graph(Last, Last, _Stream) :- !.

write_graph(Number, Last, Stream) :-
	write_path(1, Number, 0, Stream),
	Next is Number + 1,
	write_graph(Next, Last, Stream).



write_path(Last, Last, Source, Stream) :- !,
	format(Stream, "edge(~d, 1) : 0.3.~n", [Source]).

write_path(Number, Last, Source, Stream):-
	retract(new(Target)),
	Future is Target + 1,
	assert(new(Future)),
	format(Stream, "edge(~d, ~d) : 0.3.~n", [Source, Target]),
	Next is Number + 1,
	write_path(Next, Last, Target, Stream),
	write_path(Next, Last, Target, Stream).



write_clauses(Stream):-
	format(Stream, "~npath(Node, Node).~npath(Source, Target) : 0.3 :- edge(Source, Node), path(Node, Target).~n~n", []).
	
